//
// Copyright (c) 1994-1996, David McFadzean
//
// You may distribute under the terms of the Artistic License, 
// as specified in the README file.
//
// $Header: E:/simbiosys/RCS/POPULAT.H 1.1 1996/06/26 10:55:14 dbm Exp $
//

#ifndef POPULAT_H
#define POPULAT_H

#include "simbio.h"
#include "gtype.h"
#include "ptype.h"

/////////////////////////////////////////////////////////////////////////////
//
//	bioPopulation
//
     
class bioPopulation : public bioObject
{
  public:
  	ctor				bioPopulation (void);
  	dtor				~bioPopulation (void);
  	                                  
	virtual void		SortByFitness (void);
	virtual void		Breed (void);
	  	                                  
  	virtual void		SetSize (int);
  	virtual int			GetSize (void);
  	                 
  	virtual void		SetElite (int);
  	virtual int			GetElite (void);
  	
  	virtual void		SetMutationRate (double);
  	virtual double		GetMutationRate (void);
  	
  	virtual bioGType*	GenGType (void) = 0;
  	virtual bioPType*	GenPType (bioGType*) = 0;
  	  
	virtual bioPType*	GetPType (int idx);
	
	virtual double		GetMaxFitness (void);
	virtual double		GetMinFitness (void);
	virtual double		GetAvgFitness (void);
	  	  
  protected:
	bioGType*			_ChooseParent (void);
	
	int					_size; 
	int					_elite;
	int					_sorted;
		
	bioPType**			_ptypes;
	
	double				_mutationRate;
	double				_totalFitness;
	double				_maxFitness;
	double				_minFitness;
	double				_avgFitness;
};

#endif // POPULAT_H
