//
// Copyright (c) 1994-1996, David McFadzean
//
// You may distribute under the terms of the Artistic License, 
// as specified in the README file.
//
// $Header: E:/simbiosys/RCS/SIMBIO.H 1.1 1996/06/26 10:55:16 dbm Exp $
//
 
#ifndef SIMBIO_H
#define SIMBIO_H
       
#include <assert.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
       
#define ctor        /**/
#define dtor		virtual 
#define override	virtual

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef ASSERT
#define ASSERT(x) assert(x)
#endif

#ifndef ASSERT_VALID
#define ASSERT_VALID(x)	assert(x); (x)->AssertValid()
#endif

#ifndef min
#define min(a, b)	(((a) < (b)) ? (a) : (b))
#endif

#ifndef max
#define max(a, b)	(((a) > (b)) ? (a) : (b))
#endif

inline int
Round (double x)
{
	return (x < 0) ? (int) ceil (x - 0.5) : (int) floor (x + 0.5);
}

extern void			Trace (char* fmt, ...);
 
/////////////////////////////////////////////////////////////////////////////
//
//	bioObject
//           

class bioObject
{
  public:
	ctor				bioObject (void);
	dtor				~bioObject (void);
  	
  	virtual void		AssertValid (void) const;
  	
  private:
  	int					_magic;
};
   
#endif // SIMBIO_H
